#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 LimeGreen
#property indicator_color2 LimeGreen
#property indicator_color3 Orange
#property indicator_color4 Orange
#property indicator_color5 DarkGray
#property indicator_width1 2
#property indicator_width3 2
#property indicator_width5 2

//
//
//
//
//

extern int    RsiPeriod = 14;
extern double FastEma   = 12;
extern double SlowEma   = 26;
extern int    Price     = PRICE_CLOSE;

double histUp[];
double histUd[];
double histDn[];
double histDu[];
double macd[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,histUp); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histUd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,histDn); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,histDu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,macd);
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][4];
#define _fastEma 0
#define _slowEma 1
#define _trend   2
#define _slope   3

int start() 
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
         
         
         //
         //
         //
         //
         //
         

   double alphaF = 2.0/(1.0+FastEma);
   double alphaS = 2.0/(1.0+SlowEma);
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double price = iRSI(NULL,0,RsiPeriod,Price,i);
         work[r][_fastEma] = work[r-1][_fastEma]+alphaF*(price-work[r-1][_fastEma]);
         work[r][_slowEma] = work[r-1][_slowEma]+alphaS*(price-work[r-1][_slowEma]);
         macd[i] = work[r][_fastEma]-work[r][_slowEma];
              work[r][_trend] = work[r-1][_trend];
              work[r][_slope] = work[r-1][_slope];
              if (macd[i] > 0)         work[r][_trend] =  1;
              if (macd[i] < 0)         work[r][_trend] = -1;
              if (macd[i] > macd[i+1]) work[r][_slope] =  1;
              if (macd[i] < macd[i+1]) work[r][_slope] = -1;
      
         //
         //
         //
         //
         //
         
         histUp[i] = EMPTY_VALUE;
         histUd[i] = EMPTY_VALUE;
         histDn[i] = EMPTY_VALUE;
         histDu[i] = EMPTY_VALUE;
            if (work[r][_trend]==-1)
            if (work[r][_slope]==-1)
                  histDn[i] = macd[i];
            else  histDu[i] = macd[i];
            if (work[r][_trend]== 1)
            if (work[r][_slope]== 1)
                  histUp[i] = macd[i];
            else  histUd[i] = macd[i];
   }
   return(0);
}